package com.xhkjedu.sexam.controller.paper;

import com.xhkjedu.sexam.model.paper.EPaperCorrectclass;
import com.xhkjedu.sexam.service.paper.EPaperCorrectclassService;
import com.xhkjedu.sexam.vo.paper.EPClassVo;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.vo.ResultVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @author ywx
 * @classname EPaperCorrectclassController
 * @description 按班批阅
 * @date 2022/7/20 9:49
 **/
@RestController
@RequestMapping("/epc")
public class EPaperCorrectclassController {
    @Resource
    private EPaperCorrectclassService ePaperCorrectclassService;

    /**
     * 设置批阅人
     *
     * @return com.xhkjedu.vo.ResultVo
     * @Param [vo]
     * @Author ywx
     * @Date 2022/7/20 10:01
     **/
    @PostMapping("/set")
    public ResultVo setTeacher(@RequestBody EPClassVo vo) {
        Integer notice = vo.getNotice();//是否发送通知1发送2不发送
        Integer msg = vo.getMsg();//是否发送短信1发送2不发送
        Integer epid = vo.getEpid();
        Integer createid = vo.getCreateid();
        N_Utils.validation(new Object[]{epid, "试卷id", 1, createid, "操作人id", 1});
        List<EPaperCorrectclass> teachers = vo.getTeachers();
        if (N_Utils.isListEmpty(teachers)) return new ResultVo(1, "教师不能为空");
        ePaperCorrectclassService.setTeacher(epid, createid, teachers);
        return new ResultVo(0, "设置成功");
    }

    /**
     * 查看批阅人
     *
     * @return com.xhkjedu.vo.ResultVo
     * @Param [vo]
     * @Author ywx
     * @Date 2022/7/20 11:02
     **/
    @PostMapping("/detail")
    public ResultVo detail(@RequestBody EPClassVo vo) {
        Integer epid = vo.getEpid();
        N_Utils.validation(new Object[]{epid, "试卷id", 1});
        List<Map> list = ePaperCorrectclassService.listByEpId(epid);
        return new ResultVo(0, "获取成功", list);
    }
}
